function MorePick(varargin)
% Created by: Maor Asher Alon Dana
% Usage: User can choose to add a certain pick to the algorithm
% Modified by: Arthur Doroshev
%--------------------------------------------------------------------------
global comm par1 
if nargin==0
    % Set Default values:
    comm.pos=[240,227,800,550];
    comm.dirname='0';
    comm.existingfile='';
    comm.name='';
    comm.ramp(1:2,1:5)=-1;
    comm.movie=0;
    comm.plot=0;
    comm.UseFilter=0;
    comm.LoadParamaters=0;
    comm.path1='';
    comm.path2='';
    comm.spath1='';
    comm.spath2='';
else
    comm=varargin{1};
end

par=load([comm.dirname,'\','par.mat']);
par1=par;
picks=figure('Position',[350,350,300,300],'Color','White','MenuBar','none','NumberTitle','off','Name','Impedance Spectroscopy Genetic Programming','Resize','off','Tag','picks');
if nargin==0
    movegui(picks,'center')
end

handles=guihandles;
guidata(picks,handles);

%------------ Buttons: ------------%
inimutpnl=uipanel('Title','More Peaks','FontSize',10,'Parent',handles.picks,'Units','pixels','Position',[5,5,295,295],'BackgroundColor','White');

% Help:
handles.help=uicontrol('Style','pushbutton','Units','pixels','Position',[10,10,70,25],'FontWeight','bold','String','Help');

% OK:
handles.OK=uicontrol('Style','pushbutton','Units','pixels','Position',[220,10,70,25],'FontWeight','bold','Enable','on','String','OK');

% Cancle:
handles.Cancle=uicontrol('Style','pushbutton','Units','pixels','Position',[140,10,70,25],'FontWeight','bold','String','Cancle');

% text: "initial":
handles.gauss.txt=uicontrol('Style','text','Units','pixels','Position',[105,250,50,20],'BackgroundColor','White','FontSize',10,'FontWeight','bold','HorizontalAlignment','center','Parent',inimutpnl,'String','initial');

% text: "mutation":
handles.gauss.txt=uicontrol('Style','text','Units','pixels','Position',[150,250,70,20],'BackgroundColor','White','FontSize',10,'FontWeight','bold','HorizontalAlignment','center','Parent',inimutpnl,'String','mutation');

% text: "lb":
handles.gauss.txt=uicontrol('Style','text','Units','pixels','Position',[220,250,30,20],'BackgroundColor','White','FontSize',10,'FontWeight','bold','HorizontalAlignment','center','Parent',inimutpnl,'String','lb');

% text: "ub":
handles.gauss.txt=uicontrol('Style','text','Units','pixels','Position',[250,250,30,20],'BackgroundColor','White','FontSize',10,'FontWeight','bold','HorizontalAlignment','center','Parent',inimutpnl,'String','ub');

% text: "HN":
handles.hn.txt=uicontrol('Style','text','Units','pixels','Parent',inimutpnl,'Position',[5,230,113,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String','HN:');
handles.hn.initial=uicontrol('Style','checkbox','Units','pixels','Parent',inimutpnl,'Position',[122,230,80,20],'BackgroundColor','White','FontSize',10,'Max',1,'Min',0,'Value',par.hn.initial,'String','');
handles.hn.mutation=uicontrol('Style','checkbox','Units','pixels','Parent',inimutpnl,'Position',[175,230,80,20],'BackgroundColor','White','FontSize',10,'Max',1,'Min',0,'Value',par.hn.mutation,'String','');
handles.hn.lb=uicontrol('Style','edit','Units','pixels','Parent',inimutpnl,'Enable','off','Position',[220,230,30,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String',num2str(par.hn.lb));
handles.hn.ub=uicontrol('Style','edit','Units','pixels','Parent',inimutpnl,'Enable','off','Position',[255,230,30,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String',num2str(par.hn.ub));

if get(handles.hn.initial,'Value')+get(handles.hn.mutation,'Value')>0 
    set(handles.hn.txt,'FontWeight','bold');
    set(handles.hn.lb,'Enable','on');
    set(handles.hn.ub,'Enable','on');
end

% text: "KF":
handles.kf.txt=uicontrol('Style','text','Units','pixels','Parent',inimutpnl,'Position',[5,200,113,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String','KF:');
handles.kf.initial=uicontrol('Style','checkbox','Units','pixels','Parent',inimutpnl,'Position',[122,200,80,20],'BackgroundColor','White','FontSize',10,'Max',1,'Min',0,'Value',par.kf.initial,'String','');
handles.kf.mutation=uicontrol('Style','checkbox','Units','pixels','Parent',inimutpnl,'Position',[175,200,80,20],'BackgroundColor','White','FontSize',10,'Max',1,'Min',0,'Value',par.kf.mutation,'String','');
handles.kf.lb=uicontrol('Style','edit','Units','pixels','Parent',inimutpnl,'Enable','off','Position',[220,200,30,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String',num2str(par.kf.lb));
handles.kf.ub=uicontrol('Style','edit','Units','pixels','Parent',inimutpnl,'Enable','off','Position',[255,200,30,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String',num2str(par.kf.ub));

if get(handles.kf.initial,'Value')+get(handles.kf.mutation,'Value')>0
    set(handles.kf.txt,'FontWeight','bold');
    set(handles.kf.lb,'Enable','on');
    set(handles.kf.ub,'Enable','on');
end

% text: "Asymmetric Gauss":
handles.agauss.txt=uicontrol('Style','text','Units','pixels','Parent',inimutpnl,'Position',[5,155,110,40],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String','Asymmetric Gauss:');
handles.agauss.initial=uicontrol('Style','checkbox','Units','pixels','Parent',inimutpnl,'Position',[122,165,80,20],'BackgroundColor','White','FontSize',10,'Max',1,'Min',0,'Value',par.agauss.initial,'String','');
handles.agauss.mutation=uicontrol('Style','checkbox','Units','pixels','Parent',inimutpnl,'Position',[175,165,80,20],'BackgroundColor','White','FontSize',10,'Max',1,'Min',0,'Value',par.agauss.mutation,'String','');
handles.agauss.lb=uicontrol('Style','edit','Units','pixels','Parent',inimutpnl,'Enable','off','Position',[220,165,30,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String',num2str(par.agauss.lb));
handles.agauss.ub=uicontrol('Style','edit','Units','pixels','Parent',inimutpnl,'Enable','off','Position',[255,165,30,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String',num2str(par.agauss.ub));

if get(handles.agauss.initial,'Value')+get(handles.agauss.mutation,'Value')>0 
    set(handles.agauss.txt,'FontWeight','bold');
    set(handles.agauss.lb,'Enable','on');
    set(handles.agauss.ub,'Enable','on');
end

% text: "Asymmetric Lorenz":
handles.alorenz.txt=uicontrol('Style','text','Units','pixels','Parent',inimutpnl,'Position',[5,110,113,40],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String','Asymmetric Lorentz:');
handles.alorenz.initial=uicontrol('Style','checkbox','Units','pixels','Parent',inimutpnl,'Position',[122,120,80,20],'BackgroundColor','White','FontSize',10,'Max',1,'Min',0,'Value',par.alorenz.initial,'String','');
handles.alorenz.mutation=uicontrol('Style','checkbox','Units','pixels','Parent',inimutpnl,'Position',[175,120,80,20],'BackgroundColor','White','FontSize',10,'Max',1,'Min',0,'Value',par.alorenz.mutation,'String','');
handles.alorenz.lb=uicontrol('Style','edit','Units','pixels','Parent',inimutpnl,'Enable','off','Position',[220,120,30,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String',num2str(par.alorenz.lb));
handles.alorenz.ub=uicontrol('Style','edit','Units','pixels','Parent',inimutpnl,'Enable','off','Position',[255,120,30,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String',num2str(par.alorenz.ub));

if get(handles.alorenz.initial,'Value')+get(handles.alorenz.mutation,'Value')>0 
    set(handles.alorenz.txt,'FontWeight','bold');
    set(handles.alorenz.lb,'Enable','on');
    set(handles.alorenz.ub,'Enable','on');
end

% text: "Assymetric Sech":
handles.asech.txt=uicontrol('Style','text','Units','pixels','Parent',inimutpnl,'Position',[5,60,113,40],'BackgroundColor','White','FontSize',8,'HorizontalAlignment','center','String','Assymetric Sech:');
handles.asech.initial=uicontrol('Style','checkbox','Units','pixels','Parent',inimutpnl,'Position',[122,80,80,20],'BackgroundColor','White','FontSize',10,'Max',1,'Min',0,'Value',par.asech.initial,'String','');
handles.asech.mutation=uicontrol('Style','checkbox','Units','pixels','Parent',inimutpnl,'Position',[175,80,80,20],'BackgroundColor','White','FontSize',10,'Max',1,'Min',0,'Value',par.asech.mutation,'String','');
handles.asech.lb=uicontrol('Style','edit','Units','pixels','Parent',inimutpnl,'Enable','off','Position',[220,80,30,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String',num2str(par.asech.lb));
handles.asech.ub=uicontrol('Style','edit','Units','pixels','Parent',inimutpnl,'Enable','off','Position',[255,80,30,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String',num2str(par.asech.ub));

if get(handles.asech.initial,'Value')+get(handles.asech.mutation,'Value')>0
    set(handles.asech.txt,'FontWeight','bold');
    set(handles.asech.lb,'Enable','on');
    set(handles.asech.ub,'Enable','on');
end

% text: "Pseudo Voigt":
handles.pseudovoigt.txt=uicontrol('Style','text','Units','pixels','Parent',inimutpnl,'Position',[5,45,113,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String','Pseudo Voigt:');
handles.pseudovoigt.initial=uicontrol('Style','checkbox','Units','pixels','Parent',inimutpnl,'Position',[122,45,80,20],'BackgroundColor','White','FontSize',10,'Max',1,'Min',0,'Value',par.pseudovoigt.initial,'String','');
handles.pseudovoigt.mutation=uicontrol('Style','checkbox','Units','pixels','Parent',inimutpnl,'Position',[175,45,80,20],'BackgroundColor','White','FontSize',10,'Max',1,'Min',0,'Value',par.pseudovoigt.mutation,'String','');
handles.pseudovoigt.lb=uicontrol('Style','edit','Units','pixels','Parent',inimutpnl,'Enable','off','Position',[220,45,30,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String',num2str(par.pseudovoigt.lb));
handles.pseudovoigt.ub=uicontrol('Style','edit','Units','pixels','Parent',inimutpnl,'Enable','off','Position',[255,45,30,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String',num2str(par.pseudovoigt.ub));

if get(handles.pseudovoigt.initial,'Value')+get(handles.pseudovoigt.mutation,'Value')>0 
    set(handles.pseudovoigt.txt,'FontWeight','bold');
    set(handles.pseudovoigt.lb,'Enable','on');
    set(handles.pseudovoigt.ub,'Enable','on');
end

set(handles.OK,'CallBack',{@PBOK,handles});
set(handles.Cancle,'CallBack',{@PBCancle,handles});
set(handles.help,'CallBack',{@PBHelp,handles});
set(handles.hn.initial,'CallBack',{@hn_check,handles});
set(handles.hn.mutation,'CallBack',{@hn_check,handles});
set(handles.kf.initial,'CallBack',{@kf_check,handles});
set(handles.kf.mutation,'CallBack',{@kf_check,handles});
set(handles.agauss.initial,'CallBack',{@agauss_check,handles});
set(handles.agauss.mutation,'CallBack',{@agauss_check,handles});
set(handles.alorenz.initial,'CallBack',{@alorenz_check,handles});
set(handles.alorenz.mutation,'CallBack',{@alorenz_check,handles});
set(handles.asech.initial,'CallBack',{@asech_check,handles}); 
set(handles.asech.mutation,'CallBack',{@asech_check,handles});
set(handles.pseudovoigt.initial,'CallBack',{@pseudovoigt_check,handles});
set(handles.pseudovoigt.mutation,'CallBack',{@pseudovoigt_check,handles});

%------------ Functions: ------------%
% Create
%function CreateFunction()
%clc

% Cancle Button:
function PBCancle(hObject,eventdata,handles) 
global par1 par comm
par=par1;
save([comm.dirname,'\','par.mat'],'-struct','par');
delete(handles.picks)

% Help Button:
function PBHelp(hObject,eventdata,handles)  
web http://electroceramics.technion.ac.il/isgp/help.html

% Ok Button:
function PBOK(hObject,eventdata,handles) 
global par comm
par.hn.initial=get(handles.hn.initial,'Value');
par.kf.initial=get(handles.kf.initial,'Value');
par.agauss.initial=get(handles.agauss.initial,'Value');
par.alorenz.initial=get(handles.alorenz.initial,'Value');
par.asech.initial=get(handles.asech.initial,'Value');
par.pseudovoigt.initial=get(handles.pseudovoigt.initial,'Value');

par.hn.mutation=get(handles.hn.mutation,'Value');
par.kf.mutation=get(handles.kf.mutation,'Value');
par.agauss.mutation=get(handles.agauss.mutation,'Value');
par.alorenz.mutation=get(handles.alorenz.mutation,'Value');
par.asech.mutation=get(handles.asech.mutation,'Value');
par.pseudovoigt.mutation=get(handles.pseudovoigt.mutation,'Value');

par.hn.lb=str2double(get(handles.hn.lb,'String'));
par.kf.lb=str2double(get(handles.kf.lb,'String'));
par.agauss.lb=str2double(get(handles.agauss.lb,'String'));
par.alorenz.lb=str2double(get(handles.alorenz.lb,'String'));
par.asech.lb=str2double(get(handles.asech.lb,'String'));
par.pseudovoigt.lb=str2double(get(handles.pseudovoigt.lb,'String'));

par.hn.ub=str2double(get(handles.hn.ub,'String'));
par.kf.ub=str2double(get(handles.kf.ub,'String'));
par.agauss.ub=str2double(get(handles.agauss.ub,'String'));
par.alorenz.ub=str2double(get(handles.alorenz.ub,'String'));
par.asech.ub=str2double(get(handles.asech.ub,'String'));
par.pseudovoigt.ub=str2double(get(handles.pseudovoigt.ub,'String'));

if isnan(par.hn.lb) || isinf(par.hn.lb)
    errordlg('HN lower bound must be a number','error','modal');
    return
end

if isnan(par.hn.ub) || isinf(par.hn.ub)
    errordlg('HN upper bound must be a number','error','modal');
    return
end

if isnan(par.kf.lb) || isinf(par.kf.lb)
    errordlg('KF lower bound must be a number','error','modal');
    return
end

if isnan(par.kf.ub) || isinf(par.kf.ub)
    errordlg('KF upper bound must be a number','error','modal');
    return
end

if isnan(par.agauss.lb) || isinf(par.agauss.lb)
    errordlg('Assymetric Gauss lower bound must be a number','error','modal');
    return
end

if isnan(par.agauss.ub) || isinf(par.agauss.ub)
    errordlg('Assymetric Gauss upper bound must be a number','error','modal');
    return
end

if isnan(par.alorenz.lb) || isinf(par.alorenz.lb)
    errordlg('Assymetric Lorentz lower bound must be a number','error','modal');
    return
end

if isnan(par.alorenz.ub) || isinf(par.alorenz.ub)
    errordlg('Assymetric Lorentz upper bound must be a number','error','modal');
    return
end

if isnan(par.asech.lb) || isinf(par.asech.lb)
    errordlg('Assymetric Sech lower bound must be a number','error','modal');
    return
end

if isnan(par.asech.ub) || isinf(par.asech.ub)
    errordlg('Assymetric Sech upper bound must be a number','error','modal');
    return
end

if isnan(par.pseudovoigt.lb) || isinf(par.pseudovoigt.lb)
    errordlg('Pseudo Voigt lower bound must be a number','error','modal');
    return
end

if isnan(par.pseudovoigt.ub) || isinf(par.pseudovoigt.ub)
    errordlg('Pseudo Voigt upper bound must be a number','error','modal');
    return
end

% conditions: 
if  par.hn.lb<-20
    errordlg('HN lower bound must be above -20','error','modal');
    return
end

if  par.hn.ub>20
    errordlg('HN upper bound must be below 20','error','modal');
    return
end

if  par.hn.ub<par.hn.lb
    errordlg('HN upper bound must be bigger the its lower bound','error','modal');
    return
end

if  par.kf.lb<-20
    errordlg('KF lower bound must be above -20','error','modal');
    return
end

if  par.kf.ub>20
    errordlg('KF upper bound must be below 20','error','modal');
    return
end

if  par.kf.ub<par.kf.lb
    errordlg('KF upper bound must be bigger the its lower bound','error','modal');
    return
end

if  par.agauss.lb<-20
    errordlg('Assymetric Gauss lower bound must be above -20','error','modal');
    return
end

if  par.agauss.ub>20
    errordlg('Assymetric Gauss upper bound must be below 20','error','modal');
    return
end

if  par.agauss.ub<par.agauss.lb
    errordlg('Assymetric Gauss upper bound must be bigger the its lower bound','error','modal');
    return
end

if  par.alorenz.lb<-20
    errordlg('Assymetric Lorentz lower bound must be above -20','error','modal');
    return
end

if  par.alorenz.ub>20
    errordlg('Assymetric Lorentz upper bound must be below 20','error','modal');
    return
end

if  par.alorenz.ub<par.alorenz.lb
    errordlg('Assymetric Lorentz upper bound must be bigger the its lower bound','error','modal');
    return
end

if  par.asech.lb<-20
    errordlg('Assymetric Sech lower bound must be above -20','error','modal');
    return
end

if  par.asech.ub>20
    errordlg('Assymetric Sech upper bound must be below 20','error','modal');
    return
end

if  par.asech.ub<par.asech.lb
    errordlg('Assymetric Sech upper bound must be bigger the its lower bound','error','modal');
    return
end

if  par.pseudovoigt.lb<-20
    errordlg('Pseudo Voigt lower bound must be above -20','error','modal');
    return
end

if  par.pseudovoigt.ub>20
    errordlg('Pseudo Voigt upper bound must be below 20','error','modal');
    return
end

if  par.pseudovoigt.ub<par.pseudovoigt.lb
    errordlg('Pseudo Voigt upper bound must be bigger the its lower bound','error','modal');
    return
end

% save par and delete screen!
save([comm.dirname,'\','par.mat'],'-struct','par');
delete(handles.picks)

% CheckBox CallBacks:
% HN:
function hn_check(hObject,eventdata,handles)  
if get(handles.hn.initial,'Value') || get(handles.hn.mutation,'Value')
    set(handles.hn.txt,'FontWeight','bold');
    set(handles.hn.lb,'Enable','on');
    set(handles.hn.ub,'Enable','on');
else
    set(handles.hn.txt,'FontWeight','normal');
    set(handles.hn.lb,'Enable','off');
    set(handles.hn.ub,'Enable','off');
end

% KF:
function kf_check(hObject,eventdata,handles) 
if get(handles.kf.initial,'Value') || get(handles.kf.mutation,'Value')
    set(handles.kf.txt,'FontWeight','bold');
    set(handles.kf.lb,'Enable','on');
    set(handles.kf.ub,'Enable','on');
else
    set(handles.kf.txt,'FontWeight','normal');
    set(handles.kf.lb,'Enable','off');
    set(handles.kf.ub,'Enable','off');
end

% Assymetric Gauss:
function agauss_check(hObject,eventdata,handles)  
if get(handles.agauss.initial,'Value') || get(handles.agauss.mutation,'Value')
    set(handles.agauss.txt,'FontWeight','bold');
    set(handles.agauss.lb,'Enable','on');
    set(handles.agauss.ub,'Enable','on');
else
    set(handles.agauss.txt,'FontWeight','normal');
    set(handles.agauss.lb,'Enable','off');
    set(handles.agauss.ub,'Enable','off');
end

% Assymetric Lorentz:
function alorenz_check(hObject,eventdata,handles)  
if get(handles.alorenz.initial,'Value') || get(handles.alorenz.mutation,'Value')
    set(handles.alorenz.txt,'FontWeight','bold');
    set(handles.alorenz.lb,'Enable','on');
    set(handles.alorenz.ub,'Enable','on');
else
    set(handles.alorenz.txt,'FontWeight','normal');
    set(handles.alorenz.lb,'Enable','off');
    set(handles.alorenz.ub,'Enable','off');
end

% Assymetric Sech:
function asech_check(hObject,eventdata,handles) 
if get(handles.asech.initial,'Value') || get(handles.asech.mutation,'Value')
    set(handles.asech.txt,'FontWeight','bold');
    set(handles.asech.lb,'Enable','on');
    set(handles.asech.ub,'Enable','on');
else
    set(handles.asech.txt,'FontWeight','normal');
    set(handles.asech.lb,'Enable','off');
    set(handles.asech.ub,'Enable','off');
end

% Pseudo Voigt:
function pseudovoigt_check(hObject,eventdata,handles)  
if get(handles.pseudovoigt.initial,'Value') || get(handles.pseudovoigt.mutation,'Value')
    set(handles.pseudovoigt.txt,'FontWeight','bold');
    set(handles.pseudovoigt.lb,'Enable','on');
    set(handles.pseudovoigt.ub,'Enable','on');
else
    set(handles.pseudovoigt.txt,'FontWeight','normal');
    set(handles.pseudovoigt.lb,'Enable','off');
    set(handles.pseudovoigt.ub,'Enable','off');
end