function Ramp(varargin)
% Ramp(varargin)
% Usage: This function allows the user to use ramp function for analasis.
% The user can choose the number of steps and their hieght. 
% Credits: Yehu David-Horev, Alon Dana, Maor Asher.
% Modified by: Arthur Doroshev
%--------------------------------------------------------------------------
global comm data data_val u1 u2
if nargin==0
    % Set Default values:
    comm.pos=[240,227,800,550];
    comm.dirname='0';
    comm.name='';
    comm.existingfile='';
    comm.ramp(1:2,1:5)=-1;
    comm.movie=0;
    comm.plot=0;
    comm.UseFilter=0;
    comm.LoadParamaters=0;
    comm.path1='';
    comm.path2='';
    comm.path3='';
    comm.path4='';
    comm.spath1='';
    comm.spath2='';
    comm.spath3='';
    comm.spath4='';
    comm.kktcheckbox=0;
else
    comm=varargin{1};
end

screen6=figure('Position',comm.pos,'Color','White','MenuBar','none','NumberTitle','off','Name','Impedance Spectroscopy Genetic Programming','Resize','off','Tag','screen6');
movegui(screen6,'center');
handles=guihandles;
guidata(screen6,handles);

% Header:
axes('Units','pixels','Position',[322,521,156,29],'CreateFcn',{@header,handles});

% slogo:
%axes('Units','pixels','Position',[0,513,118,37],'CreateFcn',{@slogo,handles});

% text: Project Name
uicontrol('Style','text','Units','pixels','Position',[645,530,45,20],'BackgroundColor','White','FontSize',9,'HorizontalAlignment','left','String','Project: ');
n=uicontrol('Style','text','Units','pixels','Position',[690,530,110,20],'BackgroundColor','White','FontSize',9,'FontWeight','bold','HorizontalAlignment','left','String',comm.name);

% Hint:
uicontrol('Style','text','Units','pixels','Position',[80,55,250,100],'BackgroundColor','White','FontSize',12,'FontWeight','bold','HorizontalAlignment','center','String','Hint: It is better not to use Ramp, just hit Next');

v=1;
val={'','','','','','','','',''};
check={'off','off','off','off','off','off','off','off','off'};
while comm.ramp(2,v)~=-1
    v=v+1;
end

if v==1
    checkbox=0;
    check={'off','off','off','off','off','off','off','off','off'};
else
    checkbox=1;
    for i=1:5 
        if comm.ramp(1,i)==-1
            val{i}='';
            check{i}='off';
        else
            val{i}=num2str(comm.ramp(1,i));
            check{i}='on';
        end
    end
    for i=1:4
        if comm.ramp(2,i)==-1
            val{i+5}='';
            check{i+5}='off';
        else
            val{i+5}=num2str(comm.ramp(2,i));
            check{i+5}='on';
        end
    end
end

%------------ Buttons: ------------%
% Close:
handles.close=uicontrol('Style','pushbutton','Units','pixels','Position',[10,10,70,25],'FontSize',8,'FontWeight','bold','String','Close');

% Help:
handles.help=uicontrol('Style','pushbutton','Units','pixels','Position',[100,10,70,25],'FontSize',8,'FontWeight','bold','String','Help');

% next:
handles.next=uicontrol('Style','pushbutton','Units','pixels','Position',[720,10,70,25],'FontSize',8,'FontWeight','bold','String','Next  >');

% back:
handles.back=uicontrol('Style','pushbutton','Units','pixels','Position',[630,10,70,25],'FontSize',8,'FontWeight','bold','String','<  Back');

%------------ Axes: ------------%
handles.ax1=axes('Units','pixels','Position',[415,330,365,160],'Visible','on');
handles.ax2=axes('Units','pixels','Position',[415,85,365,160],'Visible','on');

%------------ Load Panel: ------------%
uipanel('Title','Ramp Data','FontSize',10,'Units','pixels','Position',[10,230,250,270],'BackgroundColor','White');

% Show Data:
handles.showdata=uicontrol('Style','pushbutton','Units','pixels','Position',[185,235,70,25],'FontSize',8,'Enable',check{1},'FontWeight','bold','String','Show Data');

% Check Box
handles.check1=uicontrol('Style','checkbox','Units','pixels','Position',[15,450,235,20],'BackgroundColor','White','FontSize',10,'Max',1,'Min',0,'CallBack',{@PBCheckbox,handles},'Value',checkbox,'String','Use a Ramp Function.');

% text: "Number of steps:":
handles.textNoS=uicontrol('Style','text','Units','pixels','Position',[33,418,150,20],'BackgroundColor','White','Enable',check{1},'FontSize',10,'HorizontalAlignment','left','String','Number of steps:');

% pop-up menu:
handles.popup=uicontrol('Style','popup','Units','pixels','Position',[160,425,40,15],'BackgroundColor','White','Enable',check{1},'FontSize',10,'Value',v,'String','|1|2|3|4');

%------------ STEPS: ------------%
% text: "1st step height:":
handles.text1=uicontrol('Style','text','Units','pixels','Position',[33,388,100,20],'BackgroundColor','White','Enable',check{1},'FontSize',10,'HorizontalAlignment','left','String','1st step height:');
handles.frtstep=uicontrol('Style','edit','Units','pixels','Position',[123,390,30,20],'BackgroundColor','White','Enable',check{1},'FontSize',10,'HorizontalAlignment','center','String',val{1});

% text: "2st step height:":
handles.text2=uicontrol('Style','text','Units','pixels','Position',[33,358,100,20],'BackgroundColor','White','Enable',check{2},'FontSize',10,'HorizontalAlignment','left','String','2st step height:');
handles.scnstep=uicontrol('Style','edit','Units','pixels','Position',[123,360,30,20],'BackgroundColor','White','Enable',check{2},'FontSize',10,'HorizontalAlignment','center','String',val{2});

% text: "3st step height:":
handles.text3=uicontrol('Style','text','Units','pixels','Position',[33,328,100,20],'BackgroundColor','White','Enable',check{3},'FontSize',10,'HorizontalAlignment','left','String','3st step height:');
handles.trdstep=uicontrol('Style','edit','Units','pixels','Position',[123,330,30,20],'BackgroundColor','White','Enable',check{3},'FontSize',10,'HorizontalAlignment','center','String',val{3});

% text: "4st step height:":
handles.text4=uicontrol('Style','text','Units','pixels','Position',[33,298,100,20],'BackgroundColor','White','Enable',check{4},'FontSize',10,'HorizontalAlignment','left','String','4st step height:');
handles.forstep=uicontrol('Style','edit','Units','pixels','Position',[123,300,30,20],'BackgroundColor','White','Enable',check{4},'FontSize',10,'HorizontalAlignment','center','String',val{4});

% text: "5st step height:":
handles.text5=uicontrol('Style','text','Units','pixels','Position',[33,268,100,20],'BackgroundColor','White','Enable',check{5},'FontSize',10,'HorizontalAlignment','left','String','5st step height:');
handles.fifstep=uicontrol('Style','edit','Units','pixels','Position',[123,270,30,20],'BackgroundColor','White','Enable',check{5},'FontSize',10,'HorizontalAlignment','center','String',val{5});

%------------ OMEGA: ------------%
% text: "w1:":
handles.textw1=uicontrol('Style','text','Units','pixels','Position',[170,373,50,20],'BackgroundColor','White','Enable',check{6},'FontSize',10,'HorizontalAlignment','left','String','w1 = ');
handles.w1=uicontrol('Style','edit','Units','pixels','Position',[200,375,30,20],'BackgroundColor','White','Enable',check{6},'FontSize',10,'HorizontalAlignment','center','String',val{6});

% text: "w2:":
handles.textw2=uicontrol('Style','text','Units','pixels','Position',[170,343,50,20],'BackgroundColor','White','Enable',check{7},'FontSize',10,'HorizontalAlignment','left','String','w2 = ');
handles.w2=uicontrol('Style','edit','Units','pixels','Position',[200,345,30,20],'BackgroundColor','White','Enable',check{7},'FontSize',10,'HorizontalAlignment','center','String',val{7});

% text: "w3:":
handles.textw3=uicontrol('Style','text','Units','pixels','Position',[170,313,50,20],'BackgroundColor','White','Enable',check{8},'FontSize',10,'HorizontalAlignment','left','String','w3 = ');
handles.w3=uicontrol('Style','edit','Units','pixels','Position',[200,315,30,20],'BackgroundColor','White','Enable',check{8},'FontSize',10,'HorizontalAlignment','center','String',val{8});

% text: "w4:":
handles.textw4=uicontrol('Style','text','Units','pixels','Position',[170,283,50,20],'BackgroundColor','White','Enable',check{9},'FontSize',10,'HorizontalAlignment','left','String','w4 = ');
handles.w4=uicontrol('Style','edit','Units','pixels','Position',[200,285,30,20],'BackgroundColor','White','Enable',check{9},'FontSize',10,'HorizontalAlignment','center','String',val{9});

data=load([comm.dirname,'\','data.gpdat'],'-ascii');
data_val=load([comm.dirname,'\','data_val.gpdat'],'-ascii');

u1=(2.*pi.*data(:,1));
u2=(data(:,2));
u3=(data(:,3));

semilogx(handles.ax1,u1,-u3)
legend(handles.ax1,'set1','northwest')
xlabel(handles.ax1,'\omega','FontWeight','bold','FontUnits','pixels','FontSize',18)
ylabel(handles.ax1,'normalized -Z" ; ramp','FontWeight','bold','FontUnits','pixels','FontSize',14)
grid(handles.ax1,'on')

plot(handles.ax2,u2,-u3)
legend(handles.ax2,'set1','northwest')
xlabel(handles.ax2,'Z''','FontWeight','bold','FontUnits','pixels','FontSize',14)
ylabel(handles.ax2,'-Z"','FontWeight','bold','FontUnits','pixels','FontSize',14)

set(handles.close,'CallBack',{@PBClose,handles});
set(handles.help,'CallBack',{@PBHelp,handles});
set(handles.popup,'CallBack',{@PBPopup,handles});
set(handles.check1,'CallBack',{@PBCheckbox,handles});
set(handles.next,'CallBack',{@PBNext,handles});
set(handles.back,'CallBack',{@PBBack,handles});
set(handles.showdata,'CallBack',{@PBShowData,handles});

if comm.check==1
    if saveramp(handles)==1
        return
    end
    delete(handles.screen6);
    Parameters(comm)
end



%------------ Functions: ------------%
% Create
%function CreateFunction() 
%clc

% Load header:
function header(hObject,eventdata,handles) 
img=imread('ISGP/h5.isgp');
image(img);
axis off
axis image

% Load slogo:
%function slogo(hObject,eventdata,handles) 
%img=imread('ISGP/slg.isgp');
%image(img);
%axis off
%axis image

% CheckBox:
function PBCheckbox(hObject,eventdata,handles) 
global comm
if get(hObject,'Value')==0
    comm.ramp(1:2,1:5)=-1; 
    set(handles.textNoS,'Enable','off');
    set(handles.popup,'Enable','off');
    set(handles.popup,'Enable','off');
    set(handles.frtstep,'Enable','off');
    set(handles.scnstep,'Enable','off');
    set(handles.trdstep,'Enable','off');
    set(handles.forstep,'Enable','off');
    set(handles.fifstep,'Enable','off');
    set(handles.text1,'Enable','off');
    set(handles.text2,'Enable','off');
    set(handles.text3,'Enable','off');
    set(handles.text4,'Enable','off');
    set(handles.text5,'Enable','off');
    set(handles.textw1,'Enable','off');
    set(handles.w1,'Enable','off');
    set(handles.textw2,'Enable','off');
    set(handles.w2,'Enable','off');
    set(handles.textw3,'Enable','off');
    set(handles.w3,'Enable','off');
    set(handles.textw4,'Enable','off');
    set(handles.w4,'Enable','off');
    set(handles.showdata,'Enable','off');
else
    set(handles.textNoS,'Enable','on');
    set(handles.popup,'Enable','on');
    set(handles.popup,'Value',1);
    set(handles.showdata,'Enable','on');
end

% Pop-up menu:
function PBPopup(hObject,eventdata,handles) 
a=get(hObject,'Value');
if a==1
    set(handles.frtstep,'Enable','off');
    set(handles.scnstep,'Enable','off');
    set(handles.trdstep,'Enable','off');
    set(handles.forstep,'Enable','off');
    set(handles.fifstep,'Enable','off');
    set(handles.text1,'Enable','off');
    set(handles.text2,'Enable','off');
    set(handles.text3,'Enable','off');
    set(handles.text4,'Enable','off');
    set(handles.text5,'Enable','off');
    set(handles.textw1,'Enable','off');
    set(handles.w1,'Enable','off');
    set(handles.textw2,'Enable','off');
    set(handles.w2,'Enable','off');
    set(handles.textw3,'Enable','off');
    set(handles.w3,'Enable','off');
    set(handles.textw4,'Enable','off');
    set(handles.w4,'Enable','off');
end

if a==2
    set(handles.frtstep,'Enable','on');
    set(handles.scnstep,'Enable','on');
    set(handles.trdstep,'Enable','off');
    set(handles.forstep,'Enable','off');
    set(handles.fifstep,'Enable','off');
    set(handles.text1,'Enable','on');
    set(handles.text2,'Enable','on');
    set(handles.text3,'Enable','off');
    set(handles.text4,'Enable','off');
    set(handles.text5,'Enable','off');
    set(handles.textw1,'Enable','on');
    set(handles.w1,'Enable','on');
    set(handles.textw2,'Enable','off');
    set(handles.w2,'Enable','off');
    set(handles.textw3,'Enable','off');
    set(handles.w3,'Enable','off');
    set(handles.textw4,'Enable','off');
    set(handles.w4,'Enable','off');
end

if a==3
    set(handles.frtstep,'Enable','on');
    set(handles.scnstep,'Enable','on');
    set(handles.trdstep,'Enable','on');
    set(handles.forstep,'Enable','off');
    set(handles.fifstep,'Enable','off');
    set(handles.text1,'Enable','on');
    set(handles.text2,'Enable','on');
    set(handles.text3,'Enable','on');
    set(handles.text4,'Enable','off');
    set(handles.text5,'Enable','off');
    set(handles.textw1,'Enable','on');
    set(handles.w1,'Enable','on');
    set(handles.textw2,'Enable','on');
    set(handles.w2,'Enable','on');
    set(handles.textw3,'Enable','off');
    set(handles.w3,'Enable','off');
    set(handles.textw4,'Enable','off');
    set(handles.w4,'Enable','off');
end

if a==4
    set(handles.frtstep,'Enable','on');
    set(handles.scnstep,'Enable','on');
    set(handles.trdstep,'Enable','on');
    set(handles.forstep,'Enable','on');
    set(handles.fifstep,'Enable','off');
    set(handles.text1,'Enable','on');
    set(handles.text2,'Enable','on');
    set(handles.text3,'Enable','on');
    set(handles.text4,'Enable','on');
    set(handles.text5,'Enable','off');
    set(handles.textw1,'Enable','on');
    set(handles.w1,'Enable','on');
    set(handles.textw2,'Enable','on');
    set(handles.w2,'Enable','on');
    set(handles.textw3,'Enable','on');
    set(handles.w3,'Enable','on');
    set(handles.textw4,'Enable','off');
    set(handles.w4,'Enable','off');
end

if a==5
    set(handles.frtstep,'Enable','on');
    set(handles.scnstep,'Enable','on');
    set(handles.trdstep,'Enable','on');
    set(handles.forstep,'Enable','on');
    set(handles.fifstep,'Enable','on');
    set(handles.text1,'Enable','on');
    set(handles.text2,'Enable','on');
    set(handles.text3,'Enable','on');
    set(handles.text4,'Enable','on');
    set(handles.text5,'Enable','on');
    set(handles.textw1,'Enable','on');
    set(handles.w1,'Enable','on');
    set(handles.textw2,'Enable','on');
    set(handles.w2,'Enable','on');
    set(handles.textw3,'Enable','on');
    set(handles.w3,'Enable','on');
    set(handles.textw4,'Enable','on');
    set(handles.w4,'Enable','on');
end

% ShowData:
function PBShowData(hObject,eventdata,handles) 
global data u1
if get(handles.check1,'Value')==0
    rampa=ones(length(u1));  
else
    if saveramp(handles)==1
        return
    end
    a=get(handles.popup,'Value');

    if a==1
        errordlg('Choose the number of steps','error','modal');
        return
    end

    if a==2
        for i=1:length(u1)
            if u1(i)<str2double(get(handles.w1,'string'))
                rampa(i)=str2double(get(handles.frtstep,'string')); 
            else
                rampa(i)=str2double(get(handles.scnstep,'string')); 
            end
        end
    end

    if a==3
        for i=1:length(u1)
            if u1(i)<str2double(get(handles.w1,'string'))
                rampa(i)=str2double(get(handles.frtstep,'string'));
            elseif u1(i)<str2double(get(handles.w2,'string'))
                rampa(i)=str2double(get(handles.scnstep,'string'));
            else
                rampa(i)=str2double(get(handles.trdstep,'string'));
            end
        end
    end

    if a==4
        for i=1:length(u1)
            if u1(i)<str2double(get(handles.w1,'string'))
                rampa(i)=str2double(get(handles.frtstep,'string'));
            elseif u1(i)<str2double(get(handles.w2,'string'))
                rampa(i)=str2double(get(handles.scnstep,'string'));
            elseif u1(i)<str2double(get(handles.w3,'string'))
                rampa(i)=str2double(get(handles.trdstep,'string'));
            else
                rampa(i)=str2double(get(handles.forstep,'string'));
            end
        end
    end

    if a==5
        for i=1:length(u1)
            if u1(i)<str2double(get(handles.w1,'string'))
                rampa(i)=str2double(get(handles.frtstep,'string'));
            elseif u1(i)<str2double(get(handles.w2,'string'))
                rampa(i)=str2double(get(handles.scnstep,'string'));
            elseif u1(i)<str2double(get(handles.w3,'string'))
                rampa(i)=str2double(get(handles.trdstep,'string'));
            elseif u1(i)<str2double(get(handles.w4,'string'))
                rampa(i)=str2double(get(handles.forstep,'string'));
            else
                rampa(i)=str2double(get(handles.fifstep,'string'));
            end
        end
    end

    semilogx(handles.ax1,u1,-data(:,3)/(-min(data(:,3))),u1,rampa)
    legend(handles.ax1,'set1','ramp')
    xlabel(handles.ax1,'\omega','FontWeight','bold','FontUnits','pixels','FontSize',18)
    ylabel(handles.ax1,'normalized -Z" ; ramp','FontWeight','bold','FontUnits','pixels','FontSize',14)
    ylim(handles.ax1,[0,max(rampa)*1.1])
    grid(handles.ax1,'on')
end

% save ramp:
function err=saveramp(handles)
global comm u1
err=0;
if get(handles.check1,'Value')==0
    rampa=ones(1,length(u1));
    save([comm.dirname,'\','rampa.GPDAT'],'rampa','-ascii')
else
    if get(handles.popup,'Value')==1
        errordlg('Choose number of steps.','error','modal');
        err=1;
        return
    end
    
    if get(handles.popup,'Value')==2
        
        comm.ramp(1,1)=str2double(get(handles.frtstep,'string'));
        if isnan(comm.ramp(1,1)) || isinf(comm.ramp(1,1)) || comm.ramp(1,1)<0
            errordlg('first step must be a positive number.','error','modal');
            err=1;
            return
        end
        
        comm.ramp(1,2)=str2double(get(handles.scnstep,'string'));
        if isnan(comm.ramp(1,2)) || isinf(comm.ramp(1,2)) || comm.ramp(1,2)<0
            errordlg('second step must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(2,1)=str2double(get(handles.w1,'string'));
        if isnan(comm.ramp(2,1)) || isinf(comm.ramp(2,1)) || comm.ramp(2,1)<0
            errordlg('w1 must be a positive number.','error','modal');
            err=1;
            return
        end

        for i=1:length(u1)
            if u1(i)<str2double(get(handles.w1,'string'))
                rampa(i)=str2double(get(handles.frtstep,'string')); 
            else
                rampa(i)=str2double(get(handles.scnstep,'string')); 
            end
        end
    end
    
    if get(handles.popup,'Value')==3

        comm.ramp(1,1)=str2double(get(handles.frtstep,'string'));
        if isnan(comm.ramp(1,1)) || isinf(comm.ramp(1,1)) || comm.ramp(1,1)<0
            errordlg('first step must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(1,2)=str2double(get(handles.scnstep,'string'));
        if isnan(comm.ramp(1,2)) || isinf(comm.ramp(1,2)) || comm.ramp(1,2)<0
            errordlg('second step must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(2,1)=str2double(get(handles.w1,'string'));
        if isnan(comm.ramp(2,1)) || isinf(comm.ramp(2,1)) || comm.ramp(2,1)<0
            errordlg('w1 must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(1,3)=str2double(get(handles.trdstep,'string'));
        if isnan(comm.ramp(1,3)) || isinf(comm.ramp(1,3)) || comm.ramp(1,3)<0
            errordlg('step three must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(2,2)=str2double(get(handles.w2,'string'));
        if isnan(comm.ramp(2,2)) || isinf(comm.ramp(2,2)) || comm.ramp(2,2)<0
            errordlg('w2 must be a positive number.','error','modal');
            err=1;
            return
        end

        for i=1:length(u1)
            if u1(i)<str2double(get(handles.w1,'string'))
                rampa(i)=str2double(get(handles.frtstep,'string'));
            elseif u1(i)<str2double(get(handles.w2,'string'))
                rampa(i)=str2double(get(handles.scnstep,'string'));
            else
                rampa(i)=str2double(get(handles.trdstep,'string'));
            end
        end
    end

    if get(handles.popup,'Value')==4

        comm.ramp(1,1)=str2double(get(handles.frtstep,'string'));
        if isnan(comm.ramp(1,1)) || isinf(comm.ramp(1,1)) || comm.ramp(1,1)<0
            errordlg('first step must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(1,2)=str2double(get(handles.scnstep,'string'));
        if isnan(comm.ramp(1,2)) || isinf(comm.ramp(1,2)) || comm.ramp(1,2)<0
            errordlg('second step must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(2,1)=str2double(get(handles.w1,'string'));
        if isnan(comm.ramp(2,1)) || isinf(comm.ramp(2,1)) || comm.ramp(2,1)<0
            errordlg('w1 must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(1,3)=str2double(get(handles.trdstep,'string'));
        if isnan(comm.ramp(1,3)) || isinf(comm.ramp(1,3)) || comm.ramp(1,3)<0
            errordlg('step three must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(2,2)=str2double(get(handles.w2,'string'));
        if isnan(comm.ramp(2,2)) || isinf(comm.ramp(2,2)) || comm.ramp(2,2)<0
            errordlg('w2 must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(1,4)=str2double(get(handles.forstep,'string'));
        if isnan(comm.ramp(1,4)) || isinf(comm.ramp(1,4)) || comm.ramp(1,4)<0
            errordlg('step four must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(2,3)=str2double(get(handles.w3,'string'));
        if isnan(comm.ramp(2,3)) || isinf(comm.ramp(2,3)) || comm.ramp(2,3)<0
            errordlg('w3 must be a positive number.','error','modal');
            err=1;
            return
        end
        for i=1:length(u1)
            if u1(i)<str2double(get(handles.w1,'string'))
                rampa(i)=str2double(get(handles.frtstep,'string'));
            elseif u1(i)<str2double(get(handles.w2,'string'))
                rampa(i)=str2double(get(handles.scnstep,'string'));
            elseif u1(i)<str2double(get(handles.w3,'string'))
                rampa(i)=str2double(get(handles.trdstep,'string'));
            else
                rampa(i)=str2double(get(handles.forstep,'string'));
            end
        end
    end

    if get(handles.popup,'Value')==5

        comm.ramp(1,1)=str2double(get(handles.frtstep,'string'));
        if isnan(comm.ramp(1,1)) || isinf(comm.ramp(1,1)) || comm.ramp(1,1)<0
            errordlg('first step must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(1,2)=str2double(get(handles.scnstep,'string'));
        if isnan(comm.ramp(1,2)) || isinf(comm.ramp(1,2)) || comm.ramp(1,2)<0
            errordlg('second step must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(2,1)=str2double(get(handles.w1,'string'));
        if isnan(comm.ramp(2,1)) || isinf(comm.ramp(2,1)) || comm.ramp(2,1)<0
            errordlg('w1 must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(1,3)=str2double(get(handles.trdstep,'string'));
        if isnan(comm.ramp(1,3)) || isinf(comm.ramp(1,3)) || comm.ramp(1,3)<0
            errordlg('step three must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(2,2)=str2double(get(handles.w2,'string'));
        if isnan(comm.ramp(2,2)) || isinf(comm.ramp(2,2)) || comm.ramp(2,2)<0
            errordlg('w2 must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(1,4)=str2double(get(handles.forstep,'string'));
        if isnan(comm.ramp(1,4)) || isinf(comm.ramp(1,4)) || comm.ramp(1,4)<0
            errordlg('step four must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(2,3)=str2double(get(handles.w3,'string'));
        if isnan(comm.ramp(2,3)) || isinf(comm.ramp(2,3)) || comm.ramp(2,3)<0
            errordlg('w3 must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(1,5)=str2double(get(handles.fifstep,'string'));
        if isnan(comm.ramp(1,5)) || isinf(comm.ramp(1,5)) || comm.ramp(1,5)<0
            errordlg('step five must be a positive number.','error','modal');
            err=1;
            return
        end

        comm.ramp(2,4)=str2double(get(handles.w4,'string'));
        if isnan(comm.ramp(2,4)) || isinf(comm.ramp(2,4)) || comm.ramp(2,4)<0
            errordlg('w3 must be a positive number.','error','modal');
            err=1;
            return
        end
        for i=1:length(u1)
            if u1(i)<str2double(get(handles.w1,'string'))
                rampa(i)=str2double(get(handles.frtstep,'string'));
            elseif u1(i)<str2double(get(handles.w2,'string'))
                rampa(i)=str2double(get(handles.scnstep,'string'));
            elseif u1(i)<str2double(get(handles.w3,'string'))
                rampa(i)=str2double(get(handles.trdstep,'string'));
            elseif u1(i)<str2double(get(handles.w4,'string'))
                rampa(i)=str2double(get(handles.forstep,'string'));
            else
                rampa(i)=str2double(get(handles.fifstep,'string'));
            end
        end
    end
end
rampa=rampa'; 
save([comm.dirname,'\','rampa.GPDAT'],'rampa','-ascii')

% Back Button:
function PBBack(hObject,eventdata,handles) 
global comm
if get(handles.check1,'Value')==0
    comm.ramp(1:2,1:5)=-1;
else
    if saveramp(handles)==1
        return
    end
end
LoadData(comm);
delete(handles.screen6);

% Next Button:
function PBNext(hObject,eventdata,handles) 
global comm
    if saveramp(handles)==1
        return
    end
Parameters(comm)
delete(handles.screen6);

% Close Button:
function PBClose(hObject,eventdata,handles) 
global comm
button=questdlg('Are you sure you want to close the ISGP?','Close Confirmation Dialog','Yes','No','Yes');
if strcmp(button,'Yes')
    if~isfolder(comm.dirname)
        h=errordlg('The directory of the project was deleted or moved.','Incorrect File Path','modal');
        uiwait(h)
    else
        save([comm.dirname,'\','comm.mat'],'comm');
    end
    delete(handles.screen6)
end

% Help Button:
function PBHelp(hObject,eventdata,handles) 
web http://electroceramics.technion.ac.il/isgp/help.html