% Function []=gp_ini()
% Usage: Solve the IS mathematical model using a GP
% Modified by: Yehu-David Horev, Maor Asher, Arthur Doroshev
%--------------------------------------------------------------------------
%%% Equation Generation:
% The number of generations data is uploaded
num_gen=par.generations;

%%% Operation parameters:
% The paramaters vector data is uploaded. Now it will be sorted
% pop size
pop_size=par.population;

%%% Reproduction:
% Swap/Add/Remove Probabilities
p_mutate=par.mutation; %swap
p_add=par.addpick; %add
p_remove=par.remove; %remove
% how many duplicates of each model are allowed (e.g. 'GLL')
p_duplicate=par.duplicate;

%%% Basic Set of Functionals:
% the paramaters names are as their use
% "mut" is for the mutation
fun_name(1)= 'D'; fun_wgt(1)=  par.delta.initial;       mut_fun_wgt(1)= par.delta.mutation;       % Pseudo Delta
fun_name(2)= 'G'; fun_wgt(2)=  par.gauss.initial;       mut_fun_wgt(2)= par.gauss.mutation;       % Gauss
fun_name(3)= 'L'; fun_wgt(3)=  par.lorenz.initial;      mut_fun_wgt(3)= par.lorenz.mutation;      % Lorenz
fun_name(4)= 'S'; fun_wgt(4)=  par.sech.initial;        mut_fun_wgt(4)= par.sech.mutation;        % Sech
fun_name(5)= 'C'; fun_wgt(5)=  par.cole.initial;        mut_fun_wgt(5)= par.cole.mutation;        % Cole Cole
fun_name(6)= 'P'; fun_wgt(6)=  par.pearson.initial;     mut_fun_wgt(6)= par.pearson.mutation;     % Pearson VII
fun_name(7)= 'A'; fun_wgt(7)=  par.losev.initial;       mut_fun_wgt(7)= par.losev.mutation;       % Losev
fun_name(8)= 'H'; fun_wgt(8)=  par.hn.initial;          mut_fun_wgt(8)= par.hn.mutation;          % HN
fun_name(9)= 'B'; fun_wgt(9)=  par.kf.initial;          mut_fun_wgt(9)= par.kf.mutation;          % KF
fun_name(10)='F'; fun_wgt(10)= par.agauss.initial;      mut_fun_wgt(10)=par.agauss.mutation;      % Assymetric Gauss
fun_name(11)='K'; fun_wgt(11)= par.alorenz.initial;     mut_fun_wgt(11)=par.alorenz.mutation;     % Assymetric Lorentz
fun_name(12)='E'; fun_wgt(12)= par.asech.initial;       mut_fun_wgt(12)=par.asech.mutation;       % Assymetric Sech
fun_name(13)='V'; fun_wgt(13)= par.pseudovoigt.initial; mut_fun_wgt(13)=par.pseudovoigt.mutation; % Pseudo Voigt
fun_name(14)='Y'; fun_wgt(14)= par.R.initial;           mut_fun_wgt(14)=par.R.mutation;           % R - Low Tau Gaussian
fun_name(15)='U'; fun_wgt(15)= par.U.initial;           mut_fun_wgt(15)=par.U.mutation;           % U - High Tau Gaussian

%%% Generate fun_set:
fun_set=[];
for i=1:15
    if fun_wgt(i)==1
        % entering the chosen peak to the fun set
        fun_set=[fun_set,fun_name(i)];
    end
end

%%% Generate mut_fun_set:
mut_fun_set=[];
for i=1:15
    if mut_fun_wgt(i)==1
        % entering the chosen peak to the fun set
        mut_fun_set=[mut_fun_set,fun_name(i)];
    end
end

% Advanced:
% Fitness
beta=par.beta; %beta=3 # of guessed peaks
lambda=par.lambda; %lambda=0 # of found peaks 
sigmamax=par.sigmamax; % the range of measured freq (in log scale)
FitnessGauss=par.fitnessgauss; % the normalization of the result's function set
% Max branches
max_trees=par.max; %1 max # of desendents per individual function
% call tree
main