function [a]=guess(x,u,y,pop)
% [a]=guess(x,u,y,pop)
% Usage: Determin the initial guess for fmincon
%        x = the guess vector from parfit
%        u = log10(tau)
%        y = Im part of the impedance
%        pop = the gene
% Written by: Yehu-David Horev
% Modified by: Maor Asher, Arthur Doroshev
%--------------------------------------------------------------------------
%l=length(x);
a=[];
% entering the wanted guess in each kind of peak
% "ceil" makes the calculation result as a whole number => 0.7=>1
% "rand" chooses a number in random from 0 to 1
for i=1:length(pop)
    if  pop(i)=='D'    || pop(i)=='Y'   || pop(i)=='U'
        % Pseudo Delta || low tau Delta || high tau Delta 
        % [ , height        , tau                       ,width           ] the width doesn't matter, because it already fixed                           
        a=[a,-rand(1)*min(y),-u(ceil(rand(1)*length(u))),-(u(2)-u(1))./10];
        
    elseif pop(i)=='G' || pop(i)=='L' || pop(i)=='S' 
        %     Gaussian || Lorentzian  || Sech         
        % [ , height        , tau                       ,sigma/gamma            ]
        a=[a,-rand(1)*min(y),-u(ceil(rand(1)*length(u))),(u(1)-u(end))/length(u)]; 
        
    elseif  pop(i)=='C' || pop(i)=='B' 
        %     Cole-Cole || Kirkwood Fous
        % [ , height        , tau                       ,alpha  ]
        a=[a,-rand(1)*min(y),-u(ceil(rand(1)*length(u))),rand(1)]; 
        
    elseif pop(i)=='P'
        % Pearson VII
        % [ , height        , tau                       ,s                      ,m]
        a=[a,-rand(1)*min(y),-u(ceil(rand(1)*length(u))),(u(1)-u(end))/length(u),1]; 
    
    elseif pop(i)=='F'     || pop(i)=='K'        || pop(i)=='A' || pop(i)=='E'
        % Asymmetric Gauss || Asymmetric Lorentz || Losev       || Asymmetric Sech
        % [ , height        , tau                       ,sigma/gamma1           ,sigma/gamma2           ]
        a=[a,-rand(1)*min(y),-u(ceil(rand(1)*length(u))),(u(1)-u(end))/length(u),(u(1)-u(end))/length(u)]; 

    elseif  pop(i)=='H'
        % Harviliak Negami
        % [ , height        , tau                       ,alpha  ,sigma/gamma            ]
        a=[a,-rand(1)*min(y),-u(ceil(rand(1)*length(u))),rand(1),(u(1)-u(end))/length(u)];
        
    elseif pop(i)=='V'
        % Pseudo Voigt
        % [ , height        , tau                       ,sigma                  ,gamma                  ,f      ]
        a=[a,-rand(1)*min(y),-u(ceil(rand(1)*length(u))),(u(1)-u(end))/length(u),(u(1)-u(end))/length(u),rand(1)];
    end
end
a=a(length(x)+1);